// HeadSplitter - Message file dumper for Naruto Shippuuden: Dairansen! Kage Bunshin Emaki
// Written April/May 2008 by xdaniel - http://magicstone.de/dzd/

#include <cstdlib>
#include <iostream>

int main(int argc, char *argv[])
{
	char misc_GameTitle[] = "Naruto Shippuuden: Dairansen! Kage Bunshin Emaki";			// set game title variable
	
	FILE* file_Msg;																		// message file handler
	FILE* file_Dump;																	// dump target file handler
	
	char src_FilenameMsg[MAX_PATH];														// filename of source message file
	char dst_FilenameDump[MAX_PATH];													// filename of dump target
	
	unsigned int src_StringCount = 0x00;												// total amount of strings in file
	unsigned int src_PtrTableOffset = 0x00000000;										// offset of pointer table
	unsigned int src_Pointer[1024];														// array for pointer list
	unsigned int src_CurrentOffset = 0x00000000;										// current offset in msg file
	
	unsigned int src_StringCount1 = 0x00;												// single byte of total string count
	unsigned int src_StringCount2 = 0x00;												// single byte of total string count
	unsigned int src_StringCount3 = 0x00;												// single byte of total string count
	unsigned int src_StringCount4 = 0x00;												// single byte of total string count
	
	unsigned short src_StringByte1 = 0x00;												// first byte of current byte pair in string
	unsigned short src_StringByte2 = 0x00;												// second byte of current byte pair in string
	unsigned int src_StringByteAdd = 0x0000;
	
	unsigned int src_PosInPtrTable = 0;													// current position in pointer table
	unsigned int src_PosInString = 0;													// current position in string
	
	bool src_ReachedStringEnd = false;													// has string end been reached?
	
	unsigned int misc_StringsProcessed = 0;												// total amount of strings dumped
	
	if (argc < 2) {																		// check if all needed arguments were given 
		printf("\n");
		printf("--------------------------------------------\n");						// if not, print this message...
		printf("HeadSplitter - NS Dairansen .msg file dumper\n");
		printf("  Written in April/May 2008 by xdaniel/DZD  \n");
		printf("--------------------------------------------\n");
		printf("\n");
		printf("Usage: <.msg file>\n", argv[0]);
		printf("\n");
		system("PAUSE");
		return EXIT_FAILURE;															// ...and exit the program
	}
	
	printf("\n");
	printf("--------------------------------------------\n");							// print the status output's header
	printf("HeadSplitter - NS Dairansen .msg file dumper\n");
	printf("  Written in April/May 2008 by xdaniel/DZD  \n");
	printf("--------------------------------------------\n");
	printf("\n");
	
	sscanf(argv[1], "%s", &src_FilenameMsg);											// get .msg filename from arguments
	
	file_Msg = fopen(src_FilenameMsg, "r+b");											// try to open .msg file
	if (file_Msg == NULL) {																// in case the file can't be opened...
		printf("Message file %s not found!\n\n", src_FilenameMsg);
		system("PAUSE");
		return EXIT_FAILURE;															// ...exit the program
	}
	
	printf("Dumping in progress...\n");													// print status message signifying the start of dumping...
	printf("  Message file:\t\t%s\n", src_FilenameMsg);									// ...and the file that's being dumped
	
	fseek(file_Msg, 0x00, SEEK_SET);													// get the total amount of messages from the file
	fread(&src_StringCount, 1, 4, file_Msg);
	
	fseek(file_Msg, 0x04, SEEK_SET);													// and get the pointer table's offset from the file
	fread(&src_PtrTableOffset, 1, 4, file_Msg);
	
																						// now go and populate the pointer list's array
	while (misc_StringsProcessed < src_StringCount) {									// ...while we haven't yet fetched all the pointers...
		fseek(file_Msg, src_PtrTableOffset + (misc_StringsProcessed * 4), SEEK_SET);	// ...go to the pointer's position in the message file...
		fread(&src_Pointer[misc_StringsProcessed], 1, 4, file_Msg);						// ...fetch it from there, put it into the array...
		
		misc_StringsProcessed++;														// ...and increase the total string counter by one
	}
	
	src_Pointer[misc_StringsProcessed] = src_PtrTableOffset;							// now, set the pointer table offset itself as the last pointer
	
	misc_StringsProcessed = 0;															// as we're done, reset the string counter to 0
	
	sprintf(dst_FilenameDump, "%s.sjs", src_FilenameMsg);								// compose the dump target file's filename
	
	file_Dump = fopen(dst_FilenameDump,"w");											// and now open the dump target file for writing
	
	printf("  Dump target file:\t%s\n", dst_FilenameDump);								// print out the target file's name
	printf("\n");
	
	fprintf(file_Dump, "// %s\n", misc_GameTitle);										// now for the dump target file's contents...
	fprintf(file_Dump, "// Dump of %s\n", src_FilenameMsg);								// ...insert some stats about the dump, like source file, etc.
	fprintf(file_Dump, "// Created using HeadSplitter, 2008 by xdaniel/DZD\n");
	fprintf(file_Dump, "\n");
	fprintf(file_Dump, "#VAR(InsTable, TABLE)\n");										// ...as well as all the atlas commands for reinserting
	fprintf(file_Dump, "#ADDTBL(\x22Insert.tbl\x22, InsTable)\n");
	fprintf(file_Dump, "#ACTIVETBL(InsTable)\n");
	fprintf(file_Dump, "\n");
	fprintf(file_Dump, "#SMA(\x22LINEAR\x22)\n");
	fprintf(file_Dump, "\n");
	fprintf(file_Dump, "#VAR(NSMsg, CUSTOMPOINTER)\n");
	fprintf(file_Dump, "#CREATEPTR(NSMsg, \x22LINEAR\x22, $0, 32)\n");
	fprintf(file_Dump, "\n");
	fprintf(file_Dump, "#JMP($000000)\n\n");
	
	src_StringCount1 = src_StringCount << 0 >> 24;										// filter out the string count variable's 4 single bytes...
	src_StringCount2 = src_StringCount << 8 >> 24;
	src_StringCount3 = src_StringCount << 16 >> 24;
	src_StringCount4 = src_StringCount << 24 >> 24;
	
	fprintf(file_Dump, "// amount of messages in file\n");								// insert the total message count into the dump for reinserting
	fprintf(file_Dump, "<$%02X>", src_StringCount4);									// ...in the form of the seperated bytes
	fprintf(file_Dump, "<$%02X>", src_StringCount3);
	fprintf(file_Dump, "<$%02X>", src_StringCount2);
	fprintf(file_Dump, "<$%02X>", src_StringCount1);
	fprintf(file_Dump, "\n\n");
	
	fprintf(file_Dump, "// pointer to new message pointer table\n");					// now insert the new pointer table's offset...
	fprintf(file_Dump, "<$08>");														// ...which is always 0x08 as we're semi-hardcoding it there
	fprintf(file_Dump, "<$00>");
	fprintf(file_Dump, "<$00>");
	fprintf(file_Dump, "<$00>");														// easier to work with it this way :)
	fprintf(file_Dump, "\n\n");
	
	fprintf(file_Dump, "#JMP($%06X)\n\n", (0x4 * src_StringCount) + 0x8);				// next, insert the command to tell atlas...
																						// ...to jump BEHIND the pointer table to insert the text
	
	while (misc_StringsProcessed < src_StringCount) {										// while we haven't reached the end of the table...
		fprintf(file_Dump, "#WRITE(NSMsg,$%06X)\n", 0x8 + (0x4 * misc_StringsProcessed));	// ...insert the atlas command for pointer writing...
		
		fprintf(file_Dump, "// ");														// ...as well as a comment statement
		
		src_PosInString = 0;															// reset the in-string position to 0
		
		while (src_ReachedStringEnd == false) {											// while we haven't reached the end of the string...
			src_CurrentOffset = src_Pointer[misc_StringsProcessed] + src_PosInString;	// set the current offset variable
			
			fseek(file_Msg, src_CurrentOffset, SEEK_SET);								// fetch one byte of the current message...
			fread(&src_StringByte1, 1, 1, file_Msg);
			fseek(file_Msg, src_CurrentOffset + 1, SEEK_SET);							// ...and the next...
			fread(&src_StringByte2, 1, 1, file_Msg);
			
			src_StringByteAdd = src_StringByte1 << 8;									// now, combine them for the byte analyzer
			src_StringByteAdd += src_StringByte2;
			
			if(src_CurrentOffset == src_Pointer[misc_StringsProcessed + 1] - 2) {		// if the current offset is two bytes before the next string
				src_ReachedStringEnd = true;											// tell the program that the string end has been reached...
				fprintf(file_Dump, "<end>\n\n\n");										// ...put the <end> tag into the dump...
				break;																	// ...and break out of the loop
			}
			
																						// NOTE:
																						// the whole control code section below is based on my
																						// observations regarding what byte pair might do what.
																						// some of them (ex. <pg>) are used under other circumstances
																						// as well. i don't even know with 100% certainity that
																						// those control codes are correctly -named-...
																						// anyway, better to just leave them in the file-to-be-inserted
																						// the way they are in the dump :)
																						
			if(src_StringByteAdd == 0x0100) {											// if the current bytes are the control code LINE FEED...
				src_ReachedStringEnd = false;											// ...tell the program that the string end is not reached yet...
				fprintf(file_Dump, "<lf>\n// ");										// ...put the <lf> tag into the dump...
			} else if(src_StringByteAdd == 0x0200) {									// if the current bytes are the control code NEW PAGE...
				src_ReachedStringEnd = false;											// ...tell the program that the string end is not reached yet...
				fprintf(file_Dump, "<pg>\n// ");										// ...put the <pg> tag into the dump...
			} else if(src_StringByteAdd == 0x0300) {									// if the current bytes are the control code WAIT FOR KEY...
				src_ReachedStringEnd = false;											// ...tell the program that the string end is not reached yet...
				fprintf(file_Dump, "<key>");											// ...put the <key> tag into the dump...
			} else if(src_StringByteAdd == 0x0500) {									// if the current bytes are the control code COLOR:RED(???)...
				src_ReachedStringEnd = false;											// ...tell the program that the string end is not reached yet...
				fprintf(file_Dump, "<color:red>");										// ...put the <color:red> tag into the dump...
			} else if(src_StringByteAdd == 0x0501) {									// if the current bytes are the control code COLOR:BLUE(???)...
				src_ReachedStringEnd = false;											// ...tell the program that the string end is not reached yet...
				fprintf(file_Dump, "<color:blue>");										// ...put the <color:blue> tag into the dump...
			} else if(src_StringByteAdd == 0x0800) {									// if the current bytes are the control code COLOR:RESET(???)...
				src_ReachedStringEnd = false;											// ...tell the program that the string end is not reached yet...
				fprintf(file_Dump, "<color:reset>");									// ...put the <color:reset> tag into the dump...
			} else if(((src_StringByteAdd >= 0x8140) && (src_StringByteAdd < 0x9000)) || ((src_StringByteAdd >= 0x9040) && (src_StringByteAdd < 0xA000)) || ((src_StringByteAdd >= 0xE000))) {		// if the current bytes are in sections valid for shift-jis characters
				src_ReachedStringEnd = false;											// ...tell the program that the string end is not reached yet...
				fprintf(file_Dump, "%s", &src_StringByte1);								// ...put the first byte as text into the dump...
				fprintf(file_Dump, "%s", &src_StringByte2);								// ...and put the second byte into it as well
			} else {																	// if nothing of the above is true...
				fprintf(file_Dump, "<$%02X>", src_StringByte1);							// ...put the first byte into the dump in tag-form
				fprintf(file_Dump, "<$%02X>", src_StringByte2);							// ...and put the second byte into it in the same way
			}
			
			src_PosInString += 2;														// now, advance to the next byte pair in the string
		}
		
		misc_StringsProcessed++;														// increase the total string count by one
		
		src_ReachedStringEnd = false;													// reset the string end marker variable
		src_StringByteAdd = 0x0000;														// reset the byte pair variable to 0x0000
		src_PosInPtrTable += 4;															// go to the next pointer in the table
	}
	
	printf("Done, %d strings have been dumped in total!\n", misc_StringsProcessed);		// insert some final stats into the dump...
	printf("\n");
	printf("Exiting.\n");
	printf("\n");
	
	fclose(file_Msg);																	// close the message file stream,...
	fclose(file_Dump);																	// ...the dump target file stream,...
	
	system("PAUSE");																	// ...wait for a keypress...
	return EXIT_SUCCESS;																// ...and exit!
}
